#ifndef battery_h
#define battery_h

/*  This library decodes Model 3 Battery CAN messages terminating in A or 2.

    This library was written by Jack Rickard of EVtv - http://www.evtv.me copyright 2019
    You are licensed to use this library for any purpose, commercial or private, 
    without restriction.
    
*/ 

#include "esp32_can.h" 	
	
	
class BATTERY //: public CANListener
{	
	public:
		void begin(int Port);
 		void gotFrame(CAN_FRAME *frame); // CAN interrupt service routine			
	  float cell[120];
    uint8_t cellindex;
    float AverageCell;
		float Amperes;   
    float rawCurrent;
    float SOC;
    float minSOC;
    float maxSOC;
    float avgSOC;
    float kWCapacity;
    float kWNeeded;
    float kWRemaining;
    float lifeCharge;
    float lifeDischarge;   
 		float Voltage;
		float reportedVoltage;
		bool debug2;
    float chargingKWH;
    float dischargingKWH;
    String SerialNumber;
  	
	private:  
    CAN_FRAME frame;
    CAN_COMMON *canPort;	
		void handle132(CAN_FRAME *frame);
    void handle292(CAN_FRAME *frame);
    void handle352(CAN_FRAME *frame);
    void handle3D2(CAN_FRAME *frame);
    void handle401(CAN_FRAME *frame);
    void handle72A(CAN_FRAME *frame); 
    float averageCell(float arraysize);   
    int milliseconds ;
    int seconds;
    int minutes;
    int hours;
   
    				
};

#endif /* battery_h */
